YANG Data Model for Bidirectional Forwarding Detection (BFD) Hardware Offloaded Session
Rajaguru Veluchamy, Ed.
Cisco Systems
India
rvelucha@cisco.com
2022
This document defines a extension YANG data model that can be used to manage Hardware Offloaded Bidirectional Forwarding Detection (BFD).
This document specially talks about BFD sessions that are offloaded to hardware.
The YANG modules in this document conform to the Network Management Datastore Architecture (NMDA).

Introduction
This document defines an extension YANG data model to base model [RFC9127] that can be used to manage BFD sessions that are offloaded to hardware. BFD is a network protocol which is used for liveness detection of arbitrary paths between systems.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Tree Diagrams
This document uses the graphical representation of data models defined in [RFC8340].

Design of the Data Model
This yang model which is extension to base BFD yang mode been designed to manage BFD HW offloaded sessions. This new "bfd" container is augmented by all the YANG modules for their respective specific information:
1. ietf-bfd-ip-sh-ext.yang augments "/routing/control-plane-protocols/control-plane-protocol/bfd/ip-sh/sessions/session" with the "session-offloaded" leaf for BFD sessions over IP single-hop extension.
2. ietf-bfd-ip-mh-ext.yang augments "/routing/control-plane-protocols/control-plane-protocol/bfd/ip-mh/sessions-groups/session-group" with the "session-offloaded" leaf for BFD sessions over IP multi-hop extension.
3. ietf-bfd-lag-ext.yang augments "/routing/control-plane-protocols/control-plane-protocol/bfd/bfd-lag/sessions/session" with the "ession-offloaded" leaf for BFD sessions over LAG extension.

BFD IP single-hop-ext hierarchy
An "ip-sh-ext" node is added under "bfd" node in control-plane-protocol. The operational state data for each BFD IP single-hop session is under this "ip-sh-ext" node.

module: ietf-bfd-ip-sh-ext
augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/bfd:bfd/bfd-ip-sh:ip-sh
	 /bfd-ip-sh:sessions/bfd-ip-sh:session:
    +--rw ip-sh-ext
       +--ro session-running-ext
          +--ro session-offloaded?   boolean

BFD IP multi-hop-ext hierarchy
An "ip-mh-ext" node is added under "bfd" node in control-plane-protocol. The operational state data for each BFD IP multi-hop session is under this "ip-mh-ext" node.

module: ietf-bfd-ip-mh-ext
augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/bfd:bfd/bfd-ip-mh:ip-mh
	 /bfd-ip-mh:session-groups/bfd-ip-mh:session-group:
          +rw session-offloaded?   boolean

BFD Over LAG-ext hierarchy
An "lag-ext" node is added under "bfd" node in control-plane-protocol. The operational state data for each BFD Over LAG session is under this "lag-ext" node.

module: ietf-bfd-lag-ext
augment /rt:routing/rt:control-plane-protocols
         /rt:control-plane-protocol/bfd:bfd/bfd-lag:lag
	 /bfd-lag:sessions/bfd-lag:session:
          +rw session-offloaded?   boolean

BFD IP single-hop ext YANG Module
This YANG module imports "ietf-bfd-ip-sh" from RFC9127 and augments.

   <CODE BEGINS> file "ietf-bfd-ip-sh-ext@2022-02-22.yang"

   module ietf-bfd-ip-sh-ext {
     yang-version 1.1;
     namespace "urn:ietf:params:xml:ns:yang:ietf-bfd-ip-sh-ext";

     prefix "bfd-ip-sh-ext";

     import ietf-bfd {
       prefix "bfd";
       reference
         "RFC 9127: A YANG Data Model for Bidirectional Forwarding
          Detection (BFD)";
     }

     import ietf-routing {
       prefix "rt";
       reference
         "RFC 8349: A YANG Data Model for Routing Management
          (NMDA version)";
     }

     import ietf-bfd-ip-sh {
       prefix "bfd-ip-sh";
       reference
         "RFC 9127: A YANG Data Model for Bidirectional Forwarding
          Detection (BFD)";
     }

     organization "IETF BFD Working Group";
     contact
       "WG Web:   <http://tools.ietf.org/wg/bfd>
        WG List:  <rtg-bfd@ietf.org>

        Editors:  Rajaguru Veluchamy (rvelucha@cisco.com)";

     description
       "This module contains the YANG definition for BFD IP single-hop
        as per RFC 5881 with some extended info.

        Copyright (c) 2018 IETF Trust and the persons
        identified as authors of the code.  All rights reserved.

        Redistribution and use in source and binary forms, with or
        without modification, is permitted pursuant to, and subject
        to the license terms contained in, the Simplified BSD License
        set forth in Section 4.c of the IETF Trust's Legal Provisions
        Relating to IETF Documents
        (http://trustee.ietf.org/license-info).

        This version of this YANG module is part of RFC XXXX; see
        the RFC itself for full legal notices.";

     reference
        "RFC 5881: Bidirectional Forwarding Detection (BFD)
         for IPv4 and IPv6 (Single Hop)
         RFC 9127: YANG Data Model for Bidirectional Forwarding
         Detection (BFD)";

     revision 2022-02-18 {
       description "Initial revision.";
       reference
          "RFC XXXX: A YANG data model for BFD IP single-hop extension";
     }

     /*
      * Augments
      */
     augment "/rt:routing/rt:control-plane-protocols/"
           + "rt:control-plane-protocol/bfd:bfd/bfd-ip-sh:ip-sh/"
           + "bfd-ip-sh:sessions/bfd-ip-sh:session" {
       description "BFD augmentation for IP single-hop-ext";
       leaf session-offloaded {
           type boolean;
           description
              "Indicates whether BFD session is running in hardware";
       }
     }
   }

<CODE ENDS>

BFD IP multi-hop ext YANG Module
This YANG module imports "ietf-bfd-ip-mh" from RFC9127 and augments.

   <CODE BEGINS> file "ietf-bfd-ip-mh-ext@2022-02-22.yang"

   module ietf-bfd-ip-mh-ext {
     yang-version 1.1;
     namespace "urn:ietf:params:xml:ns:yang:ietf-bfd-ip-mh-ext";
     prefix "bfd-ip-mh-ext";

     import ietf-bfd {
       prefix "bfd";
       reference
         "RFC 9127: A YANG Data Model for Bidirectional Forwarding
          Detection (BFD)";
     }

     import ietf-routing {
       prefix "rt";
       reference
         "RFC 8349: A YANG Data Model for Routing Management
          (NMDA version)";
     }

     import ietf-bfd-ip-mh {
       prefix "bfd-ip-mh";
       reference
         "RFC 9127: A YANG Data Model for Bidirectional Forwarding
          Detection (BFD)";
     }

     organization "IETF BFD Working Group";
     contact
       "WG Web:   <http://tools.ietf.org/wg/bfd>
        WG List:  <rtg-bfd@ietf.org>

        Editors:  Rajaguru Veluchamy (rvelucha@cisco.com)";

     description
       "This module contains the YANG definition for BFD IP single-hop
        as per RFC 5881 with some extended info.

        Copyright (c) 2018 IETF Trust and the persons
        identified as authors of the code.  All rights reserved.

        Redistribution and use in source and binary forms, with or
        without modification, is permitted pursuant to, and subject
        to the license terms contained in, the Simplified BSD License
        set forth in Section 4.c of the IETF Trust's Legal Provisions
        Relating to IETF Documents
        (http://trustee.ietf.org/license-info).

        This version of this YANG module is part of RFC XXXX; see
        the RFC itself for full legal notices.";

     reference
        "RFC 5881: Bidirectional Forwarding Detection (BFD)
         for IPv4 and IPv6 (Single Hop)
         RFC 9127: YANG Data Model for Bidirectional Forwarding
         Detection (BFD)";

     revision 2022-02-18 {
       description "Initial revision.";
       reference
          "RFC XXXX: A YANG data model for BFD IP single-hop extension";
     }

     /*
      * Augments
      */
     augment "/rt:routing/rt:control-plane-protocols/"
           + "rt:control-plane-protocol/bfd:bfd/bfd-ip-mh:ip-mh/"
           + "bfd-ip-mh:session-groups/bfd-ip-mh:session-group" {
       description "BFD augmentation for IP multi-hop-ext";
       leaf session-offloaded {
           type boolean;
           description
              "Indicates whether BFD session is running in hardware";
       }
     }
   }

<CODE ENDS>

BFD Over LAG ext YANG Module
This YANG module imports "ietf-bfd-lag" from RFC9127 and augments.

   <CODE BEGINS> file "ietf-bfd-lag-ext@2022-02-22.yang"

   module ietf-bfd-lag-ext {
     yang-version 1.1;
     namespace "urn:ietf:params:xml:ns:yang:ietf-bfd-lag-ext";
     prefix "bfd-lag-ext";

     import ietf-bfd {
       prefix "bfd";
       reference
         "RFC 9127: A YANG Data Model for Bidirectional Forwarding
          Detection (BFD)";
     }

     import ietf-routing {
       prefix "rt";
       reference
         "RFC 8349: A YANG Data Model for Routing Management
          (NMDA version)";
     }

     import ietf-bfd-lag {
       prefix "bfd-lag";
       reference
         "RFC 9127: A YANG Data Model for Bidirectional Forwarding
          Detection (BFD)";
     }

     organization "IETF BFD Working Group";
     contact
       "WG Web:   <http://tools.ietf.org/wg/bfd>
        WG List:  <rtg-bfd@ietf.org>

        Editors:  Rajaguru Veluchamy (rvelucha@cisco.com)";

     description
       "This module contains the YANG definition for BFD IP single-hop
        as per RFC 5881 with some extended info.

        Copyright (c) 2018 IETF Trust and the persons
        identified as authors of the code.  All rights reserved.

        Redistribution and use in source and binary forms, with or
        without modification, is permitted pursuant to, and subject
        to the license terms contained in, the Simplified BSD License
        set forth in Section 4.c of the IETF Trust's Legal Provisions
        Relating to IETF Documents
        (http://trustee.ietf.org/license-info).

        This version of this YANG module is part of RFC XXXX; see
        the RFC itself for full legal notices.";

     reference
        "RFC 5881: Bidirectional Forwarding Detection (BFD)
         for IPv4 and IPv6 (Single Hop)
         RFC 9127: YANG Data Model for Bidirectional Forwarding
         Detection (BFD)";

     revision 2022-02-18 {
       description "Initial revision.";
       reference
          "RFC XXXX: A YANG data model for BFD IP single-hop extension";
     }

     /*
      * Augments
      */
     augment "/rt:routing/rt:control-plane-protocols/"
           + "rt:control-plane-protocol/bfd:bfd/bfd-lag:lag/"
           + "bfd-lag:sessions/bfd-lag:session" {
       description "BFD augmentation for LAG ext";
       leaf session-offloaded {
           type boolean;
           description
             "Indicates whether BFD session is running in hardware";
       }
     }
   }

<CODE ENDS>

Security Considerations
TBD.

IANA Considerations
None.

Acknowledgements
I would like to thank Vengada Prasad Govindan for his support and guidance on this work.

Normative References
[RFC9127]
[RFC2119]
[RFC8174]
[RFC8340]

Change log
RFC Editor: Remove this section upon publication as an RFC.